/*
 * gtk 1.x 2.x  ٸ 
 *
 * Copyright (C) 2002, Nam SungHyun and various contributors
 */
#include "config.h"
#include "pcMain.h"

#if GTK_MAJOR_VERSION >= 2
#include <sys/time.h>

/* gdk_time_get() {{{1 */
guint32
gdk_time_get(void)
{
    struct timeval end;
    struct timeval elapsed;
    guint32 milliseconds;

    static int f = 1;
    static struct timeval start;
    if (f)
    {
	f=0;
	gettimeofday (&start, NULL);
    }

    gettimeofday (&end, NULL);

    if (start.tv_usec > end.tv_usec)
    {
	end.tv_usec += 1000000;
	end.tv_sec--;
    }
    elapsed.tv_sec = end.tv_sec - start.tv_sec;
    elapsed.tv_usec = end.tv_usec - start.tv_usec;

    milliseconds = (elapsed.tv_sec * 1000) + (elapsed.tv_usec / 1000);

    return milliseconds;
}

/* PC_IconvStr() {{{1 */
char *
PC_IconvStr(const char *from, int fromlen)
{
    g_return_val_if_fail(from != NULL && fromlen > 0, (char *) from);

    if (g_utf8_validate(from, fromlen, NULL) == FALSE)
    {
	gchar *p;
	gsize bytes_read, bytes_written;

	p = g_locale_to_utf8(from, fromlen, &bytes_read, &bytes_written,
			     NULL);
	if (p != NULL)
	    return p;
    }

    return (char *) from;
}
/* }}} */

#else /* GTK_MAJOR_VERSION < 2 */

/* }}} */
#endif

